unit hiUserActive;

interface

uses Kol,Share,Debug, Messages, Windows;

type
  THIUserActive = class(TDebug)
   private
    function GetNATime: DWORD;
    function  _onMessage( var Msg: TMsg; var Rslt: Integer ): Boolean;  
   public
    _event_onActive:THI_Event;

    constructor Create(Control: PControl); 
    procedure _var_NoActiveTime(var _Data:TData; Index:word);
  end;

implementation

constructor THIUserActive.Create;
begin
  inherited Create;
  if Assigned(Applet) then 
     Applet.Children[0].OnMessage := _OnMessage;  
end;

function THIUserActive.GetNATime: DWORD;
var
  LII : TLastInputInfo;
  CurrentIdleInterval : DWORD;
begin
  FillChar(LII, SizeOf(LII), 0);
  LII.cbSize := SizeOf(LII);
  GetLastInputInfo(LII);
  CurrentIdleInterval := GetTickCount - LII.dwTime;
  Result := CurrentIdleInterval;
end;

procedure THIUserActive._var_NoActiveTime;
begin
   dtInteger(_Data, GetNATime);  
end;

function THIUserActive._onMessage( var Msg: TMsg; var Rslt: Integer ): Boolean;
begin
  Result := false;
  case Msg.Message of
    WM_KEYFIRST..WM_KEYLAST, 
    WM_MOUSEFIRST..WM_MOUSELAST:
      _hi_onEvent(_event_onActive); 
  end; 
end;

end.
